import { createApp } from 'vue'
import App from './App.vue'
import router, {beforeInit} from './router'
import './style/index.scss'
import 'virtual:svg-icons-register'    // 【svg-icons相关】
import initComponent from '@/plugins/initComponent'
import initProperties from '@/plugins/initProperties'
import 'default-passive-events'
import './browerPatch'
import { createPinia } from 'pinia'
import ElementPlus from 'element-plus'
import 'element-plus/dist/index.css'
import 'highlight.js/styles/github-dark.css';

const app = createApp(App)
app.use(createPinia())
await initProperties(app)
initComponent(app)
await beforeInit()
app.use(router)
app.use(ElementPlus as any)
app.mount('#app')
// 设置为 true 以在浏览器开发工具的 performance/timeline 面板中启用对组件初始化、编译、渲染和更新的性能追踪。
app.config.performance = true

